Package io.vertx.openapi.validation

## Interface RequestValidator

-     public interface RequestValidator

  The `RequestValidator` requires the `parameters` in a specific format to be able to parse and validate them. This is especially true for exploded parameters. The following table shows how the value of a parameter of a request must be stored in a `ValidatableRequest` object. For these examples the key of those values is always color.

  These are the initial values for each type:
  - primitive (string) -> "blue"
  - array -> ["blue","black","brown"]
  - object -> { "R": 100, "G": 200, "B": 150 }
  For cookie parameters `ValidatedRequest.getCookies()`

       +--------+---------+-------+-----------+------------------------------------+-------------------------+
       | style  | explode | empty | primitive | array                              | object                  |
       +--------+---------+-------+-----------+------------------------------------+-------------------------+
       | form   | false   |       | blue      | blue,black,brown                   | R,100,G,200,B,150       |
       +--------+---------+-------+-----------+------------------------------------+-------------------------+
       | form   | true    |       | blue      | color=blue&color=black&color=brown | R=100&G=200&B=150       |
       +--------+---------+-------+-----------+------------------------------------+-------------------------+

  For header parameters `ValidatedRequest.getHeaders()`

       +--------+---------+-------+-----------+------------------------------------+-------------------------+
       | style  | explode | empty | primitive | array                              | object                  |
       +--------+---------+-------+-----------+------------------------------------+-------------------------+
       | simple | false   |       | blue      | blue,black,brown                   | R,100,G,200,B,150       |
       +--------+---------+-------+-----------+------------------------------------+-------------------------+
       | simple | true    |       | blue      | blue,black,brown                   | R=100,G=200,B=150       |
       +--------+---------+-------+-----------+------------------------------------+-------------------------+

  For path parameters `ValidatedRequest.getPathParameters()`

       +--------+---------+--------+-------------+-------------------------------------+--------------------------+
       | style  | explode | empty  | primitive   | array                               | object                   |
       +--------+---------+--------+-------------+-------------------------------------+--------------------------+
       | simple | false   |        | blue        | blue,black,brown                    | R,100,G,200,B,150        |
       +--------+---------+--------+-------------+-------------------------------------+--------------------------+
       | simple | true    |        | blue        | blue,black,brown                    | R=100,G=200,B=150        |
       +--------+---------+--------+------ ------+-------------------------------------+--------------------------+
       | label  | false   | .      | .blue       | .blue,black,brown                   | .R,100,G,200,B,150       |
       +--------+---------+--------+-------------+-------------------------------------+--------------------------+
       | label  | true    | .      | .blue       | .blue.black.brown                   | .R=100.G=200.B=150       |
       +--------+---------+--------+-------------+-------------------------------------+--------------------------+
       | matrix | false   | ;color | ;color=blue | ;color=blue,black,brown             | ;color=R,100,G,200,B,150 |
       +--------+---------+-------+--------+-------------------------------------------+--------------------------+
       | matrix | true    | ;color | ;color=blue | ;color=blue;color=black;color=brown | ;R=100;G=200;B=150       |
       +--------+---------+--------+-------------+-------------------------------------+--------------------------+

  For query parameters `ValidatedRequest.getQuery()`

       +----------------+---------+-------+------------+-----------------------------------+--------------------------+
       | style          | explode | empty | primitive | array                              | object                   |
       +----------------+---------+-------+----------+-------------------------------------+--------------------------+
       | form           | false   |       | blue      | blue,black,brown                   | R,100,G,200,B,150        |
       +----------------+---------+-------+-----------+------------------------------------+--------------------------+
       | form           | true    |       | blue      | color=blue&color=black&color=brown | R=100&G=200&B=150        |
       +----------------+---------+-------+------ ----+------------------------------------+--------------------------+
       | spaceDelimited | false   | not yet supported                                                                 /
       +----------------+---------+-------+------ ----+------------------------------------+--------------------------+
       | spaceDelimited | true    | not yet supported                                                                 /
       +----------------+---------+-------+------ ----+------------------------------------+--------------------------+
       | pipeDelimited  | false   | not yet supported                                                                 /
       +----------------+---------+-------+------ ----+------------------------------------+--------------------------+
       | pipeDelimited  | true    | not yet supported                                                                 /
       +----------------+---------+-------+------ ----+------------------------------------+--------------------------+
       | spaceDelimited | true    | not yet supported                                                                 /
       +----------------+---------+-------+------ ----+------------------------------------+--------------------------+

- - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static RequestValidator` | `create​(Vertx vertx, OpenAPIContract contract)` | Create a new `RequestValidator`.
    `Future<ValidatedRequest>` | `validate​(HttpServerRequest request)` | Like `validate(ValidatableRequest, String)`, but the operationId and `ValidatableRequest` are determined from the passed request.
    `Future<ValidatedRequest>` | `validate​(HttpServerRequest request, String operationId)` | Like `validate(ValidatableRequest, String)`, but `ValidatableRequest` are directly extracted from the passed request.
    `Future<ValidatedRequest>` | `validate​(ValidatableRequest params, String operationId)` | Validates the passed request parameters against the operation defined in the related OpenAPI contract.

- - ### Method Detail

    - #### create

          static RequestValidator create​(Vertx vertx,
                                         OpenAPIContract contract)

      Create a new `RequestValidator`.
      Parameters:
        `vertx` - the related Vert.x instance
        `contract` - the related `OpenAPIContract`
      Returns:
        an instance of `RequestValidator`.

    - #### validate

          Future<ValidatedRequest> validate​(HttpServerRequest request)

      Like `validate(ValidatableRequest, String)`, but the operationId and `ValidatableRequest` are determined from the passed request.

      Note: Determining the operationId is expensive. If possible use `validate(HttpServerRequest, String)`.
      Parameters:
        `request` - the request to validate
      Returns:
        A succeeded Future with the parsed and validated request parameters, or a failed Future containing ValidationException.

    - #### validate

          Future<ValidatedRequest> validate​(HttpServerRequest request,
                                            String operationId)

      Like `validate(ValidatableRequest, String)`, but `ValidatableRequest` are directly extracted from the passed request.
      Parameters:
        `request` - the request to validate
        `operationId` - the id of the related operation.
      Returns:
        A succeeded Future with the parsed and validated request parameters, or a failed Future containing ValidationException.

    - #### validate

          Future<ValidatedRequest> validate​(ValidatableRequest params,
                                            String operationId)

      Validates the passed request parameters against the operation defined in the related OpenAPI contract.
      Parameters:
        `params` - the request parameters to validate.
        `operationId` - the id of the related operation.
      Returns:
        A succeeded Future with the parsed and validated request parameters, or a failed Future containing ValidationException.